Summary:        Image loading, saving, rendering, and manipulation library
Name:           imlib2
Version:        1.4.7
Release:        1
License:        Imlib2
Group:          System Environment/Libraries
URL:            http://docs.enlightenment.org/api/imlib2/html/
Source0:        http://downloads.sourceforge.net/enlightenment/%{name}-%{version}.tar.bz2
Patch0:         %{name}-%{version}-aix.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

BuildRequires:  bzip2 >= 1.0.2-4
BuildRequires:  freetype2-devel >= 2.7-1
BuildRequires:  libungif-devel >= 4.1.4-1
BuildRequires:  libid3tag-devel >= 0.15.1b-3
BuildRequires:  libjpeg-devel >= 9b-2
BuildRequires:  libpng-devel >= 1.6.26-1
BuildRequires:  libtiff-devel >= 4.0.6-2
BuildRequires:  pkg-config
BuildRequires:  zlib-devel >= 1.2.3-7

Requires:       bzip2 >= 1.0.2-4
Requires:       freetype2 >= 2.7-1
Requires:       libungif >= 4.1.4-1
Requires:       libid3tag >= 0.15.1b-3
Requires:       libjpeg >= 9b-2
Requires:       libpng >= 1.6.26-1
Requires:       libtiff >= 4.0.6-2
Requires:       pkg-config
Requires:       zlib >= 1.2.3-7

%define _libdir64 %{_prefix}/lib64

%description
Imlib 2 is a library that does image file loading and saving as well
as rendering, manipulation, arbitrary polygon support, etc.  It does
ALL of these operations FAST. Imlib2 also tries to be highly
intelligent about doing them, so writing naive programs can be done
easily, without sacrificing speed.  This is a complete rewrite over
the Imlib 1.x series. The architecture is more modular, simple, and
flexible.

The library is available as 32-bit and 64-bit.


%package devel
Summary:        Development package for %{name}
Group:          Development/Libraries
Requires:       %{name} = %{version}-%{release}
Requires:       freetype2-devel >= 2.7-1
Requires:       pkg-config

%description devel
This package contains development files for %{name}.

Imlib 2 is a library that does image file loading and saving as well
as rendering, manipulation, arbitrary polygon support, etc.  It does
ALL of these operations FAST. Imlib2 also tries to be highly
intelligent about doing them, so writing naive programs can be done
easily, without sacrificing speed.  This is a complete rewrite over
the Imlib 1.x series. The architecture is more modular, simple, and
flexible.

If you are compiling a 32-bit program, no special compiler options are
needed.

If you are compiling a 64-bit program, you have to compile and link your
application with "xlc -q64" or "gcc -maix64".


%package id3tag-loader
Summary:        Imlib2 id3tag-loader
License:        GPLv2+
Group:          System Environment/Libraries
Requires:       %{name} = %{version}-%{release}
Requires:       libid3tag >= 0.15.1b-3

%description id3tag-loader
This package contains a plugin which makes imlib2 capable of parsing id3 tags
of mp3 files. This plugin is packaged separately because it links with
libid3tag which is GPLv2+, thus making imlib2 and apps using it subject to the
conditions of the GPL version 2 (or at your option) any later version.


%prep
%setup -q
%patch0
mkdir ../32bit
mv * ../32bit
mv ../32bit .
mkdir 64bit
cd 32bit && tar cf - . | (cd ../64bit ; tar xpf -)


%build
export CONFIG_SHELL=/usr/bin/ksh
export CONFIG_ENV_ARGS=/usr/bin/ksh

export CC="xlc_r -D__EXPORT__="

cd 64bit
# first build the 64-bit version
export OBJECT_MODE=64
export LDFLAGS="-L/opt/freeware/lib64 -L/opt/freeware/lib -Wl,-blibpath:/opt/freeware/lib64:/opt/freeware/lib:/usr/lib:/lib -Wl,-bmaxdata:0x80000000"
./configure \
    --prefix=%{_prefix} \
    --libdir=%{_libdir64} \
    --enable-shared --disable-static \
    --enable-visibility-hiding=no
make %{?_smp_mflags}

cd ../32bit
# now build the 32-bit version
export OBJECT_MODE=32
export LDFLAGS="-L/opt/freeware/lib -Wl,-blibpath:/opt/freeware/lib:/usr/lib:/lib -Wl,-bmaxdata:0x80000000"
./configure \
    --prefix=%{_prefix} \
    --enable-shared --disable-static \
    --enable-visibility-hiding=no
make %{?_smp_mflags}


%install
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}

cd 64bit
export OBJECT_MODE=64
gmake DESTDIR=${RPM_BUILD_ROOT} install

(
  cd ${RPM_BUILD_ROOT}%{_bindir}
  for f in * ; do
    mv -f ${f} ${f}_64
  done
)

cd ../32bit
export OBJECT_MODE=32
gmake DESTDIR=${RPM_BUILD_ROOT} install

/usr/bin/strip -X32_64 ${RPM_BUILD_ROOT}%{_bindir}/* || :

rm -f ${RPM_BUILD_ROOT}%{_bindir}/imlib2_test*

(
  cd ${RPM_BUILD_ROOT}%{_libdir64}
  for f in *.a ; do
    /usr/bin/ar -X64 -x ${f}
  done

  cd ${RPM_BUILD_ROOT}%{_libdir}
  for f in *.a ; do
    /usr/bin/ar -X32 -x ${f}
  done
)

(
  cd ${RPM_BUILD_ROOT}%{_libdir}/%{name}/loaders
  for f in *.a ; do
      /usr/bin/ar -X32 -x ${f}
  done
  cd ${RPM_BUILD_ROOT}%{_libdir64}/%{name}/loaders
  for f in *.a ; do
      /usr/bin/ar -X64 -x ${f}
  done

  cd ${RPM_BUILD_ROOT}%{_libdir}/%{name}/filters
  for f in *.a ; do
      /usr/bin/ar -X32 -x ${f}
  done
  cd ${RPM_BUILD_ROOT}%{_libdir64}/%{name}/filters
  for f in *.a ; do
      /usr/bin/ar -X64 -x ${f}
  done
)

# add the 64-bit shared objects to the shared libraries containing already the
# 32-bit shared objects
/usr/bin/ar -X64 -q ${RPM_BUILD_ROOT}%{_libdir}/libImlib2.a ${RPM_BUILD_ROOT}%{_libdir64}/libImlib2.so.1

(
  cd ${RPM_BUILD_ROOT}
  for dir in bin include lib lib64
  do
    mkdir -p usr/${dir}
    cd usr/${dir}
    ln -sf ../..%{_prefix}/${dir}/* .
    cd -
  done
)


%clean
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}


%files
%defattr(-,root,system,-)
%doc 32bit/COPYING 32bit/AUTHORS 32bit/README 32bit/ChangeLog 32bit/TODO
%{_bindir}/imlib2_*
%{_libdir}/*.a
%{_libdir}/*.so*
%{_libdir64}/*.so*
%{_datadir}/%{name}
%dir %{_libdir}/%{name}/
%dir %{_libdir64}/%{name}/
%dir %{_libdir}/%{name}/filters/
%dir %{_libdir64}/%{name}/filters/
%{_libdir}/%{name}/filters/*.a
%{_libdir64}/%{name}/filters/*.a
%{_libdir}/%{name}/filters/*.so
%{_libdir64}/%{name}/filters/*.so
%dir %{_libdir}/%{name}/loaders/
%dir %{_libdir64}/%{name}/loaders/
%{_libdir}/%{name}/loaders/[a-g,j-z]*.a
%{_libdir64}/%{name}/loaders/[a-g,j-z]*.a
%{_libdir}/%{name}/loaders/[a-g,j-z]*.so
%{_libdir64}/%{name}/loaders/[a-g,j-z]*.so
/usr/bin/imlib2_*
/usr/lib/*.a
/usr/lib/*.so*
/usr/lib64/*.so*


%files devel
%defattr(-,root,system,-)
%doc 32bit/doc/*.gif 32bit/doc/*.html
%{_bindir}/imlib2-config*
%{_includedir}/*
%{_libdir}/*.la
%{_libdir64}/*.la
%{_libdir}/%{name}/filters/*.la
%{_libdir64}/%{name}/filters/*.la
%{_libdir}/%{name}/loaders/[a-g,j-z]*.la
%{_libdir64}/%{name}/loaders/[a-g,j-z]*.la
%{_libdir}/pkgconfig/*.pc
%{_libdir64}/pkgconfig/*.pc
/usr/bin/imlib2-config*
/usr/include/*
/usr/lib/*.la
/usr/lib64/*.la


%files id3tag-loader
%defattr(-,root,system,-)
%{_libdir}/%{name}/loaders/id3.a
%{_libdir64}/%{name}/loaders/id3.a
%{_libdir}/%{name}/loaders/id3.so
%{_libdir64}/%{name}/loaders/id3.so
%{_libdir}/%{name}/loaders/id3.la
%{_libdir64}/%{name}/loaders/id3.la


%changelog
* Mon Dec 19 2016 Michael Perzl <michael@perzl.org> - 1.4.7-1
- updated to version 1.4.7
- added RTL-stlye shared libraries

* Fri Jan 23 2015 Michael Perzl <michael@perzl.org> - 1.4.6-1
- updated to version 1.4.6

* Tue Jun 12 2012 Michael Perzl <michael@perzl.org> - 1.4.5-1
- updated to version 1.4.5

* Fri Oct 08 2010 Michael Perzl <michael@perzl.org> - 1.4.4-2
- fixed imlib2 loader problem

* Tue Jun 01 2010 Michael Perzl <michael@perzl.org> - 1.4.4-1
- updated to version 1.4.4

* Thu Nov 26 2009 Michael Perzl <michael@perzl.org> - 1.4.2-1
- updated to version 1.4.2

* Sun Sep 14 2008 Michael Perzl <michael@perzl.org> - 1.4.1-1
- first version for AIX V5.1 and higher
